*-------------------------------------*
*      Calcul et definition de        *
*       Checksum de bootblock         *
*-------------------------------------*
	opt	c-,o+,ow-

* -------------------------------------
OpenLib	=	-$228
CloseLib	=	-$19e
DoIO	=	-$1c8
AddPort	=	-$162
RemPort	=	-$168
FindTask	=	-$126
OpenDev	=	-444
CloseDev	=	-450
* -------------------------------------
Open	=	-30
Close	=	-36
Output	=	-60
Input	=	-54
Write	=	-48
* ------------------------------------- la phrase du checksum
PCS	=	"This"	; RAMP (checksum)
PR	=	" is "	; AGE  (root)

	section	code,code_c
	
	rsreset	
dosbase	rs.l	1
destHD	rs.l	1
outputHD	rs.l	1
inputHD	rs.l	1
val	rs.w	1
VARSIZE	rs.w	0
	
Start	movem.l	d0-d7/a0-a6,-(sp)
	lea	VARS(pc),a5
	
	movea.l	4.w,a6
	lea	dosname(pc),a1
	moveq	#0,d0
	jsr	OpenLib(a6)		
	move.l	d0,dosbase(a5)
	tst.l	d0
	beq	erreur
		
	movea.l	d0,a6		dosbase
	jsr	Output(a6)		sortie courante
	move.l	d0,outputHD(a5)

	jsr	Input(a6)		entree courante
	move.l	d0,inputHD(a5)
;---------------------------------------- load boot from disk
;	movea.l	4.w,a6		execbase
;	suba.l	a1,a1
;	jsr	FindTask(a6)	find own task
;	
;	lea	ReadReply(pc),a1
;	move.l	d0,$10(a1)		IOReadReply SigTask
;	jsr	AddPort(a6)
;	
;	lea	DiskIO(pc),a1	IOStructure
;	move.l	#0,d0		DF0:
;	clr.l	d1
;	lea	TrdDevice(pc),a0
;	jsr	OpenDev(a6)
;	tst.l	d0
;	bne	NoTrackdisk
;	
;	lea	Mess1(pc),a0	lecture...
;	moveq	#LMess1,d3
;	bsr	Afftext
;
;	bsr	Demand		attend
;	
;	lea	DiskIO(pc),a1
;	lea	ReadReply(pc),a0
;	move.l	a0,14(a1)
;	move.w	#2,$1c(a1)
;	move.l	#2*512,$24(a1)
;	move.l	#BootBlock,$28(a1)
;	move.l	#0*512,$2c(a1)
;	movea.l	4.w,a6
;	jsr	DoIO(a6)
;	
;	lea	DiskIO(pc),a1
;	move.w	#9,$1c(a1)
;	move.l	#0,$24(a1)
;	jsr	DoIO(a6)
;	
;	lea	ReadReply(pc),a1
;	jsr	RemPort(a6)
;	
;	lea	DiskIO(pc),a1
;	jsr	CloseDev(a6)						
;--------------------------------------------------- end load boot from disk
	lea	Mess2(pc),a0	calcul...
	moveq	#LMess2,d3
	bsr	Afftext
	
	bsr	Check
	
	clr.l	d3
	clr.l	d2
	lea	Mess3(pc),a0	affiche...
	moveq	#LMess3,d3
	bsr	Afftext

	lea	Mess4(pc),a0	affiche...
	moveq	#LMess4,d3
	bsr	Afftext

	lea	Blk(pc),a0
	lea	Blank(pc),a1
	bsr	printf
	lea	Blk2(pc),a0
	lea	Blank+2(pc),a1
	bsr	printf
	
	lea	NumSum(pc),a0
	lea	CheckSum(pc),a1
	bsr	printf
	lea	NumSum2(pc),a0
	lea	CheckSum+2(pc),a1
	bsr	printf
;------------------------------------------------------- write new boot in ram:boot	
;	lea	Mess1(pc),a0	ecriture...
;	moveq	#LMess1,d3
;	bsr	Afftext
;
;	bsr	Demand		attend
	
	movea.l	dosbase(a5),a6
	move.l	#1006,d2		mode write
	move.l	#destfile,d1
	jsr	Open(a6)		
	move.l	d0,destHD(a5)
		
	move.l	dosbase(a5),a6
	move.l	destHD(a5),d1
	lea	Boot(pc),a0
	move.l	a0,d2
	move.l	#2*512,d3	
	jsr	Write(a6)		
	
	movea.l	dosbase(a5),a6
	move.l	destHD(a5),d1
	jsr	Close(a6)		
	
	lea	Mess5(pc),a0	termine...
	moveq	#LMess5,d3
	bsr	Afftext
		
	bsr	Demand		attend

NoTrackdisk		
	movea.l	dosbase(a5),a1
	movea.l	4.w,a6
	jsr	CloseLib(a6)
	
erreur	movem.l	(sp)+,d0-d7/a0-a6
	moveq	#0,d0
	rts	
* ------------------------------------------------
Afftext	movea.l	dosbase(a5),a6
	move.l	a0,d2
	move.l	outputHD(a5),d1
	jsr	Write(a6)
	rts
* ----------------------------------------------
* Demande parametres
Demand:
	movea.l	dosbase(a5),a6		
	move.l	inputHD(a5),d1	
	move.l	#inbuff,d2
	moveq	#1,d3
	jsr	-42(a6)		writetxt()	
	rts
* -------------------------------------------------
* Commande Printf du C par JP Vitulli/Loriciel
Printf:	movem.l	d0-d7/a0-a6,-(sp)
	moveq	#0,d7
	lea	Putch(pc),a2
	lea	bavard(pc),a3
	clr.b	(a3)+
	movea.l	4.w,a6
	jsr	-522(a6)		RawDoFmt()
	movea.l	a3,a0
	move.b	d7,-(a0)
Puts	moveq	#0,d3
	move.b	(a0)+,d3
	move.l	a0,d2
	move.l	outputHD(a5),d1
	movea.l	dosbase(a5),a6
	jsr	Write(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts
Putch	move.b	d0,(a3)+
	addq.l	#1,d7
	rts			
* --------------------------------------------------------------
* - MAIN PROGRAM : compute checksum
* --------------------------------------------------------------
Check	move.l	#PCS,FinalSum
	move.l	#$444f5300,BootBlock	; put "DOS"
	move.l	#PR,BootBlock+8		; put root
	move.l	#PR,Root
* -------------------------------------------
Return	lea	BootBlock+8(pc),a0	root
	lea	1016(a0),a1
	clr.l	d0
	clr.l	d1
	move.w	#"DO",d0		DOS
	move.w	#$5300,d1
Loop	add.w	(a0)+,d0
	bcs	Out1
Skip1	add.w	(a0)+,d1
	bcs	Out2
Skip2	btst	#6,$bfe001
	beq	exit
	cmp.l	a0,a1
	bne.s	Loop
* ---------------------------------------------
	not.w	d0
	not.w	d1
	swap.w	d0
	move.w	d1,d0
	move.l	d0,CheckSum1
	move.l	CheckSum1(pc),OldCheckSum
	
	move.l	FinalSum(pc),d2
	move.l	CheckSum1(pc),d3
	cmp.l	d2,d3			new checksum=final checksum ?
	bge.s	ok
	sub.l	d2,d3
	swap	d3
	move.l	d3,Blank		put word
	bra.s	return2
ok	sub.l	d2,d3
	move.l	d3,Blank	
Return2	lea	BootBlock+8(pc),a0	root
	lea	1016(a0),a1
	clr.l	d0
	clr.l	d1
	move.w	#"DO",d0		DOS
	move.w	#$5300,d1
Loop2	add.w	(a0)+,d0
	bcs.s	Out3
Skip3	add.w	(a0)+,d1
	bcs	Out4
Skip4	btst	#6,$bfe001
	beq.s	exit
	cmp.l	a0,a1
	bne.s	Loop2
* ---------------------------------------------
	not.w	d0
	not.w	d1
	swap.w	d0
	move.w	d1,d0
		
	move.l	d0,CheckSum
	move.l	d0,BootBlock+4
	
	move.l	FinalSum(pc),d2
	move.l	CheckSum(pc),d3
	sub.l	d2,d3
	tst.l	d3
	beq.s	exit
	add.l	d3,Blank
	bra.s	Return2
exit	rts
* ---------------------------------------------
Out1	add.w	#1,d1
	move.w	$dff006,val(a5)
	andi.w	#$f00,val(a5)
	move.w	val(a5),$dff180
	bra	Skip1
Out2	add.w	#1,d0
	move.w	$dff006,val(a5)
	andi.w	#$0f0,val(a5)
	move.w	val(a5),$dff180
	bra	Skip2		
Out3	add.w	#1,d1
	move.w	$dff006,val(a5)
	andi.w	#$f00,val(a5)
	move.w	val(a5),$dff180
	bra	Skip3
Out4	add.w	#1,d0
	move.w	$dff006,val(a5)
	andi.w	#$0f0,val(a5)
	move.w	val(a5),$dff180
	bra	Skip4		
* ------------------------------------------------ datas
destfile	dc.b	"ram:boot",0
	even
Mess1	dc.b	"Insert Target Disk in DF0: and then press return...",$a
LMess1	equ	*-Mess1
	even
Mess2	dc.b	"checksum Computed! press left mouse button...",$a
LMess2	equ	*-Mess2
	even
Mess3	dc.b	"OldCheckSum = "
OldCheckSum	dc.l	0
	dc.b	" CheckSum = "
CheckSum	dc.l	0
	dc.b	" Final CheckSum = "
FinalSum	dc.l	0
	dc.b	" Root = "
Root	dc.l	0
	dc.b	$a
LMess3	equ	*-Mess3
	even	
Mess4	dc.b	"Press Return...",$a
LMess4	equ	*-Mess4
	even
Mess5	dc.b	"boot saved in ram:boot. press return....",$a
LMess5	equ	*-Mess5
	even
NumSum	dc.b	" Sum = %d",0
NumSum2	dc.b	"%d",$a,0
Blk	dc.b	" Blank = %d",0
Blk2	dc.b	"%d",$a,0
	even
CheckSum1	dc.l	0
VARS	ds.b	VARSIZE
	even
dosname	dc.b	'dos.library',0
	even
TrdDevice
	dc.b	'trackdisk.device',0
	even
DiskIO	ds.l	20
ReadReply	ds.l	8

inbuff	ds.l	1
bavard	ds.b	13
	even
Boot	dc.w	0

;----------------------------------------- original Boot
BootBlock
	;ds.b	2*512	; if load from disk (but having to find space left)
	include	Boot.s	; source of boot (to get real size of boot)
LBlock	equ	*-BootBlock

Blank	ds.b	2*512-LBlock	; verif space left in boot for adding long word
	end	
